barang/urls.py
from django.urls import path
from .views import barang_view, semua_barang_view, barang_view_buy, barang_view_review

app_name = 'barang'

urlpatterns = [
    path('<int:id>/buy', barang_view_buy, name='barang-buy'),
    path('<int:id>/review', barang_view_review, name='barang-review'),
    path('<int:id>', barang_view, name='barang-detail'),
    path('all/<str:filter>', semua_barang_view, name='barang-filter'),
    path('all', semua_barang_view, name='barang-all')
]

kupon/urls.py
from django.urls import path
from .views import semua_kupon_view, kupon_api_view

app_name = 'kupon'

urlpatterns = [
    path('', semua_kupon_view, name='semua-kupon'),
    path('api/semua', kupon_api_view, name='kupon-api')
]

onlineshop/urls.py
from django.contrib import admin
from django.urls import path, include
from register import views as regviews

urlpatterns = [
    path('admin/', admin.site.urls),
    path('accounts/', include('django.contrib.auth.urls')),
    path('barang/', include('barang.urls')),
    path('kategori/', include('kategori.urls')),
    path('kupon/', include('kupon.urls')),
    path('transaksi/', include('transaksi.urls')),
    path('ulasan/', include('ulasan.urls')),
    path('shopadmin/', include('shopadmin.urls')),
    path('', include('landing.urls')),
    path('register/', include('register.urls', namespace='register')),
    path('keranjang/', include('keranjang.urls')),
    path('', include('django.contrib.auth.urls')),
    path('', include('social_django.urls', namespace='social')),
    # path('login/', regviews.login, name='login'),
]

transaksi/urls.py
from django.urls import path
from .views import all_transaction_view, cepat_view, beli_cepat_view, riwayat_cepat_view

app_name = 'transaksi'

urlpatterns = [
    path('', all_transaction_view, name='all-transactions'),
    path('cepat/', cepat_view, name='transaksi-cepat'),
    path('riwayat-cepat', riwayat_cepat_view, name='riwayat-cepat'),
    path('api/beli-cepat', beli_cepat_view, name='beli-cepat')
]

transaksi/models.py
from django.db import models
from barang.models import Barang
from kupon.models import Kupon


class Transaksi(models.Model):
    nama_pembeli = models.CharField(
        max_length=100, verbose_name="Nama Pembeli")
    barang = models.ForeignKey(Barang, on_delete=models.CASCADE)
    kupon = models.ForeignKey(
        Kupon, on_delete=models.SET_NULL, blank=True, null=True)
    total = models.DecimalField(max_digits=30, decimal_places=2)
    tanggal = models.DateTimeField(auto_now_add=True)

transaksi/forms.py
from django import forms
from .models import Transaksi
from kupon.models import Kupon


class BeliBarangForm(forms.Form):
    def __init__(self, stok, *args, **kwargs):
        super(BeliBarangForm, self).__init__(*args, **kwargs)
        self.fields['jumlah'] = forms.IntegerField(min_value=1,
                                                   max_value=stok)
    nama_pembeli = forms.CharField(max_length=100, label="Nama Pembeli")
    kupon = forms.ModelChoiceField(
        queryset=Kupon.objects.all(), required=False)
    jumlah = forms.IntegerField(min_value=1)

transaksi/views.py
import json
from django.shortcuts import render
from django.contrib.auth.decorators import login_required
from django.http import JsonResponse

from tk2.models import KeranjangBarang, KeranjangBarangEntry, KeranjangBarangTransaksi
from kupon.models import Kupon
from .models import Transaksi


def all_transaction_view(request):
    transaksi_all = Transaksi.objects.all().order_by("-tanggal")
    context = {
        "transaksi_all": transaksi_all
    }
    return render(request, "transaksi/semua.html", context)


def cepat_view(request):
    try:
        keranjang_user = KeranjangBarang.objects.get(
            user=request.user, active=True)
    except:
        keranjang_user = None

    context = {
        "keranjang": keranjang_user
    }

    return render(request, "transaksi/cepat.html", context)


def beli_cepat_view(request):
    if request.method == "POST":
        try:
            keranjang_user = KeranjangBarang.objects.get(
                user=request.user, active=True)

            data = json.loads(request.body)

            if KeranjangBarangEntry.objects.filter(keranjang=keranjang_user).exists():
                kupon = Kupon.objects.filter(id=data.get("kupon_id")).first()
                trx = KeranjangBarangTransaksi(
                    keranjang=keranjang_user, kupon=kupon, total_harga=data.get("total_harga"), user=request.user)
                trx.save()
                keranjang_user.active = False
                keranjang_user.save()

                # kurangi stok
                for b in keranjang_user.entry.all():
                    br = b.barang
                    br.stok -= b.jumlah
                    br.save()
            else:
                raise Exception("Tidak ada barang di keranjang!")

            return JsonResponse({'success': True})
        except Exception as e:
            return JsonResponse({'success': False, 'error': str(e)})


def riwayat_cepat_view(request):
    try:
        transaksi_user = KeranjangBarangTransaksi.objects.filter(
            user=request.user)
    except:
        transaksi_user = None

    context = {
        "transaksi_all": transaksi_user
    }

    return render(request, "transaksi/riwayat.html", context)

transaksi/templates/transaksi/cepat.html
{% extends 'base.html' %} {% block content %} {% load static %}
{% load humanize %}
<div class="container">
  <h2 class="">
    Keranjang Belanja
  </h2>
  <div class="row mt-3">
    {% if keranjang %}
        <table class="table table-striped">
        <thead>
            <tr>
            <th scope="col">Barang</th>
            <th scope="col">Qty</th>
            <th scope="col">Harga</th>
            </tr>
        </thead>
        <tbody>
        {% for barang in keranjang.entry.all %}
        <tr>
        <td>{{barang.barang.nama}}</td>
        <td>{{barang.jumlah}}
        </td>
        <td>Rp. {{barang.harga_total|intcomma}}</td>
        </tr>
        {% endfor %}
        </tbody>
        <tfoot>
            <tr>
                <td colspan="2"><strong>Kupon</strong> (<i>contoh: '<40' atau '>50'</40></i>)</td>
                <td><select id="kupon" tabindex="1" style="width: 75%;"><option></option></select></td>
            </tr>
            <tr>
                <td colspan="2"><strong>Total</strong></td>
                <td colspan="1">Rp. <span id="total-price">{{keranjang.total|intcomma}}</span></td>
            </tr>
        </tfoot>
        </table>
        <button class="btn btn-info" id="btn-buy">Beli</button>
    {% else %}
    Keranjang Belanja anda kosong!
    {% endif %}
  </div>
</div>

{% load static %} {% endblock %} {% block head %}
<title>Keranjang | Tk.PePeW Online Shop</title>
<link rel="stylesheet" href="https://unpkg.com/swiper/css/swiper.min.css" />

{% endblock %}
{% block js %}
<script>
    let kupons;
    const total = Number(`{{keranjang.total}}`.replace(',', '.'));
    let totald = total;
    let kuponid;
    async function initialize() {
        const source = await fetch(`{% url 'kupon:kupon-api' %}`);
        const data = await source.json();
        kupons = data.kupons.map((k) => {
            return {
                ...k,
                text: k.kode
            }
        })

        $("#kupon").select2({
            placeholder: 'Cari Kupon',
            allowClear: true,
            data: kupons,
            templateResult: (state) => {
                return `${state.text} | ${state.persen_diskon}%`
            },
            matcher: matcher
        });
    }

    function matcher(params, data) {
        // If there are no search terms, return all of the data
        if ($.trim(params.term) === '') {
            return data;
        }

        // Do not display the item if there is no 'text' property
        if (typeof data.text === 'undefined') {
            return null;
        }

        // add matcher for <40 and >40
        const r = (/^>(\d+)/.exec(params.term))
        const m1 = r ? r[1] : null;
        if (m1) {
            return Number(data.persen_diskon) > Number(m1) ? data : null;
        }

        const r2 = (/<(\d+)/.exec(params.term))
        const m2 = r2 ? r2[1] : null;
        if (m2) {
            return Number(data.persen_diskon) < Number(m2) ? data : null;
        }

        if (data.text.toLowerCase().includes(params.term.toLowerCase())) {
            return data;
        }

        return null;
    }

    $(function() {
        initialize();

        $("#kupon").on("select2:select", (e) => {
            const d = e.params.data;
            if (total > d.min_harga){
                totald = total * (100 - Number(d.persen_diskon))/100;
                $("#total-price").text(totald.toLocaleString());
                kuponid = d.id;
            }
            else{
                alert("Total Harga Belum Mencapai Minimal !")
            }
        })

        $("#btn-buy").click(async () => {
            const csrftoken = Cookies.get('csrftoken');

            const notyf = new Notyf({
                types: [
                    {
                    type: 'info',
                    background: 'orange',
                    icon: false
                    }
                ]
            });

            notyf.open({
                type: 'info',
                message: `Sedang membuat transaksi!`
            })

            const data = {
                total_harga: totald,
                kupon_id: kuponid
            }

            const response = await fetch(`{% url 'transaksi:beli-cepat' %}`, {
                method: 'POST',
                body: JSON.stringify(data),
                headers: { "X-CSRFToken": csrftoken },
            });

            const result = await response.json();

            notyf.dismissAll();

            if (result.success) {
                notyf.success(`Sukses membuat Transaksi! Redirect dalam 5 detik!`);
                setTimeout(function(){
                    window.location.href = `{% url 'transaksi:riwayat-cepat'%}`;
                }, 5000);
            } else {
                notyf.error(`Gagal membuat Transakasi!`);
                notyf.error(result.error);
            }
        });
    });
</script>
{% endblock%}

transaksi/templates/transaksi/riwayat.html
{% extends 'base.html' %} {% block content %} {% load static %}
<div class="container">
  <h2 class="text-center">
    Transaksi
  </h2>
  {% if user.is_authenticated %}
  <div class="row mt-3">
    {% for transaksi in transaksi_all %}
    <div class="col-sm-12">
      {% load humanize %}
      <div
        class="online-card text-center all-product-card mb-4 d-flex justify-content-between flex-column"
      >
        <div class="d-flex flex-column align-items-start px-4 py-2 mb-2">
          <h2>{{transaksi.user.username|truncatechars:13}}</h2>
          <span class="text-muted"
            >bought {{transaksi.keranjang.entry.all|length}} unique items.</span>
          {% if transaksi.kupon.kode %}
          <span class="text-muted">using coupon {{transaksi.kupon.kode}}</span>
          {% else %}
          <span class="text-muted">using no coupon</span>
          {% endif %}
          <span class="text-muted">{{transaksi.timestamp|naturaltime}}</span>
        </div>
        <div class="d-flex flex-column">
          <span class="text-muted mt-2"
            >total:
            <strong>Rp. {{transaksi.total_harga|intcomma}}</strong></span
          >
        </div>
      </div>
    </div>
    {% endfor %} 
    {% if not transaksi_all %}
    Tidak ada transaksi 
    {% endif %}
  </div>
  {% else %}
  <h3>Anda belum melakukan login.</h3>
  {% endif %}
</div>
{% endblock %} {% block head %}
<title>
  Transaksi |Tk.PePeW Online Shop
</title>
<link rel="stylesheet" href="{% static 'barang/styles.css' %}" />
<link rel="stylesheet" href="{% static 'transaksi/styles.css' %}" />

{% endblock %} {% block rightsidecontent %}
<div>{% include 'includes/recommended.html' %}</div>
{% endblock %}

transaksi/templates/transaksi/semua.html
{% extends 'base.html' %} {% block content %} {% load static %}
<div class="container">
  <h2 class="text-center">
    Transaksi
  </h2>
  {% if user.is_authenticated %}
  <div class="row mt-3">
    {% for transaksi in transaksi_all %}
    <div class="col-sm-12">
      {% load humanize %}
      <div
        class="online-card text-center all-product-card mb-4 d-flex justify-content-between flex-column"
      >
        <div class="d-flex flex-column align-items-start px-4 py-2 mb-2">
          <h2>{{transaksi.nama_pembeli|truncatechars:13}}</h2>
          <span class="text-muted"
            >bought
            <a href="{% url 'barang:barang-detail' id=transaksi.barang.id %}"
              >{{transaksi.barang.nama}}</a
            ></span
          >
          {% if transaksi.kupon.kode %}
          <span class="text-muted">using coupon {{transaksi.kupon.kode}}</span>
          {% else %}
          <span class="text-muted">using no coupon</span>
          {% endif %}
          <span class="text-muted">{{transaksi.tanggal|naturaltime}}</span>
        </div>
        <div class="d-flex flex-column">
          <img src="{{transaksi.barang.gambar}}" class="transaksi-card-image" />
          <span class="text-muted mt-2"
            >total: <strong>{{transaksi.total|intcomma}}</strong></span
          >
        </div>
      </div>
    </div>
    {% endfor %}
  </div>
  {% else %}
  <h3>Anda belum melakukan login.</h3>
  {% endif %}
</div>
{% endblock %} {% block head %}
<title>
  Transaksi |Tk.PePeW Online Shop
</title>
<link rel="stylesheet" href="{% static 'barang/styles.css' %}" />
<link rel="stylesheet" href="{% static 'transaksi/styles.css' %}" />

{% endblock %} {% block rightsidecontent %}
<div>{% include 'includes/recommended.html' %}</div>
{% endblock %}